# cloudy2clear_ML

I Have created this directory as a place to experiment with techniques to remove clouds from satellite imagery, with the goal being to create a temporal and spatially continous LST dataset over Johannesburg and Abidjan

So far this directory contains:

- a training dataset with cloudmasks taken from cloudy days overlaid over clear days. the data is available at `data/MODIS_LST_Cloud_GAN_training_data.zarr` and the code used to generate this at `01_create_training_dataset/`
- a fun and very unsuccessful attempt at using a pretrained model at `02_pix2pix/01_using_a_pretrained_SD_model.ipynb`
- an example training the pix2pix model on RGB images of the training set at `02_fine_tune_pix2pix.ipynb`
- an html viewing page of the above results is available at `02_pix2pix/pytorch-CycleGAN-and-pix2pix/results/cloudy2clear_pix2pix/test_latest/index.html`

Ideas for moving forward:
- A glaring error in the current implementation is the colormap used to produce the RGB image from the raster data is not fixed to a constant vmin, vmax.
- incorporate a text prompt with additional information ie: time of day and day of year
- the above cloudy2clear_pix2pix model obviously does not taken into account shading from clouds. So the obvious next step is to download and clean the MODIS cloud cover product. I have started this but am a bit stumped with finding a file driver to open the data with xarray.
- how this could be intergrated into a model I am not certain. Perhaps an interesting and easy to produce idea could be to place LST, elevation and cloud-cover as seperate 'RGB' bands as input into the model. How a test/train set could be produce I am not certain. 
- I still need to create a function to convert the RGB images back to raster values to compare results and investigate how much precision is lost in the process of going from raster > RGB > raster. 
- an obvious area is also to create a new custom model that uses a similar training process to pix2pix but specifically for raster data would be worthwhile. I started something like this at `old/_building_and_training_a_custom_SD_model.ipynb` but struggled to make any progress so have left it incomplete. 
- and lastly comparing the results using different models. 